Index: trunk/Cocoa/Pester/Source/Manip.pm
===================================================================
--- trunk/Cocoa/Pester/Source/Manip.pm	(revision 617)
+++ trunk/Cocoa/Pester/Source/Manip.pm	(revision 618)
@@ -1405,18 +1295,18 @@
       } elsif (/^epochNEGATIVE (\d+)$/) {
         $s=$1;
-        $date=&DateCalc("1970-01-01 00:00 GMT","-0:0:$s");
+        $date=DateCalc("1970-01-01 00:00 GMT","-0:0:$s");
       } elsif (/^epoch\s*(\d+)$/i) {
         $s=$1;
-        $date=&DateCalc("1970-01-01 00:00 GMT","+0:0:$s");
+        $date=DateCalc("1970-01-01 00:00 GMT","+0:0:$s");
 
       } elsif ( (/^$now$/i   &&  ($tmp="Now"))  ||
                 (/^$today$/i &&  ($tmp="Today")) ) {
         # now, today
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
         $date=$Curr{$tmp};
         if ($time) {
           return ""
-            if (&Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
-          $date=&Date_SetTime($date,$h,$mn,$s);
+            if (_Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
+          $date=Date_SetTime($date,$h,$mn,$s);
         }
         last PARSE;
@@ -1425,11 +1315,11 @@
         # yesterday, tomorrow
         ($offset)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
         $offset=$Lang{$L}{"OffsetH"}{lc($offset)};
-        $date=&DateCalc_DateDelta($Curr{"Now"},$offset,\$err,0);
+        $date=_DateCalc_DateDelta($Curr{"Now"},$offset,\$err,0);
         if ($time) {
           return ""
-            if (&Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
-          $date=&Date_SetTime($date,$h,$mn,$s);
+            if (_Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
+          $date=Date_SetTime($date,$h,$mn,$s);
         }
         last PARSE;
@@ -1442,10 +1332,10 @@
 
   if (! $date) {
-    return ""  if (&Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
-    $date=&Date_Join($y,$m,$d,$h,$mn,$s);
-  }
-  $date=&Date_ConvTZ($date,$z);
+    return ""  if (_Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
+    $date=_Date_Join($y,$m,$d,$h,$mn,$s);
+  }
+  $date=Date_ConvTZ($date,$z);
   if ($midnight) {
-    $date=&DateCalc_DateDelta($date,"+0:0:0:1:0:0:0");
+    $date=_DateCalc_DateDelta($date,"+0:0:0:1:0:0:0");
   }
   return $date;
@@ -1454,5 +1344,5 @@
 sub ParseDate {
   print "DEBUG: ParseDate\n"  if ($Curr{"Debug"} =~ /trace/);
-  &Date_Init()  if (! $Curr{"InitDone"});
+  Date_Init()  if (! $Curr{"InitDone"});
   my($args,@args,@a,$ref,$date)=();
   @a=@_;
@@ -1469,10 +1359,10 @@
   $ref=ref $args;
   if (! $ref) {
-    return $args  if (&Date_Split($args));
+    return $args  if (_Date_Split($args));
     @args=($args);
   } elsif ($ref eq "ARRAY") {
     @args=@$args;
   } elsif ($ref eq "SCALAR") {
-    return $$args  if (&Date_Split($$args));
+    return $$args  if (_Date_Split($$args));
     @args=($$args);
   } else {
@@ -1490,5 +1380,5 @@
  PARSE: while($#a>=0) {
     $date=join(" ",@a);
-    $date=&ParseDateString($date);
+    $date=ParseDateString($date);
     last  if ($date);
     pop(@a);
@@ -1502,6 +1392,6 @@
 sub Date_Cmp {
   my($D1,$D2)=@_;
-  my($date1)=&ParseDateString($D1);
-  my($date2)=&ParseDateString($D2);
+  my($date1)=ParseDateString($D1);
+  my($date2)=ParseDateString($D2);
   return $date1 cmp $date2;
 }
@@ -1548,13 +1438,13 @@
   $Curr{"InCalc"}=1;
 
-  if ($tmp=&ParseDateString($D1)) {
+  if ($tmp=ParseDateString($D1)) {
     # If we've already parsed the date, we don't want to do it a second
     # time (so we don't convert timezones twice).
-    if (&Date_Split($D1)) {
+    if (_Date_Split($D1)) {
       push(@date,$D1);
     } else {
       push(@date,$tmp);
     }
-  } elsif ($tmp=&ParseDateDelta($D1)) {
+  } elsif ($tmp=ParseDateDelta($D1)) {
     push(@delta,$tmp);
   } else {
@@ -1565,11 +1455,11 @@
   }
 
-  if ($tmp=&ParseDateString($D2)) {
-    if (&Date_Split($D2)) {
+  if ($tmp=ParseDateString($D2)) {
+    if (_Date_Split($D2)) {
       push(@date,$D2);
     } else {
       push(@date,$tmp);
     }
-  } elsif ($tmp=&ParseDateDelta($D2)) {
+  } elsif ($tmp=ParseDateDelta($D2)) {
     push(@delta,$tmp);
     $mode = $Curr{"Mode"};
@@ -1585,10 +1475,10 @@
 
   if ($#date==1) {
-    $ret=&DateCalc_DateDate(@date,$mode);
+    $ret=_DateCalc_DateDate(@date,$mode);
   } elsif ($#date==0) {
-    $ret=&DateCalc_DateDelta(@date,@delta,\$err,$mode);
+    $ret=_DateCalc_DateDelta(@date,@delta,\$err,$mode);
     $$errref=$err  if ($ref);
   } else {
-    $ret=&DateCalc_DeltaDelta(@delta,$mode);
+    $ret=_DateCalc_DeltaDelta(@delta,$mode);
   }
   $ret;
@@ -1634,5 +1524,5 @@
   my($workweek)=$Cnf{"WorkWeekEnd"}-$Cnf{"WorkWeekBeg"}+1;
 
-  &Date_Init()  if (! $Curr{"InitDone"});
+  Date_Init()  if (! $Curr{"InitDone"});
   # A sign can be a sequence of zero or more + and - signs, this
   # allows for deltas like '+ -2 days'.
@@ -1790,5 +1680,5 @@
   }
 
-  $delta=&Delta_Normalize($delta,$Curr{"Mode"});
+  $delta=_Delta_Normalize($delta,$Curr{"Mode"});
   return $delta;
 }
@@ -1800,11 +1690,11 @@
   my($format,%f,$out,@out,$c,$date1,$date2,$tmp)=();
   my($scalar)=();
-  $date=&ParseDateString($date);
+  $date=ParseDateString($date);
   return  if (! $date);
 
   my($y,$m,$d,$h,$mn,$s)=($f{"Y"},$f{"m"},$f{"d"},$f{"H"},$f{"M"},$f{"S"})=
-    &Date_Split($date, 1);
+    _Date_Split($date, 1);
   $f{"y"}=substr $f{"Y"},2;
-  &Date_Init()  if (! $Curr{"InitDone"});
+  Date_Init()  if (! $Curr{"InitDone"});
 
   if (! wantarray) {
@@ -1822,6 +1712,6 @@
   s/^0/ /;
   $f{"f"}=$_;
-  $f{"U"}=&Date_WeekOfYear($m,$d,$y,7);
-  $f{"W"}=&Date_WeekOfYear($m,$d,$y,1);
+  $f{"U"}=Date_WeekOfYear($m,$d,$y,7);
+  $f{"W"}=Date_WeekOfYear($m,$d,$y,1);
 
   # check week 52,53 and 0
@@ -1834,9 +1724,9 @@
       $mm=1;
       $yy++;
-      if (&Date_WeekOfYear($mm,$dd,$yy,1)==2) {
+      if (Date_WeekOfYear($mm,$dd,$yy,1)==2) {
         $f{"G"}=$yy;
         $f{"W"}=1;
       }
-      if (&Date_WeekOfYear($mm,$dd,$yy,7)==2) {
+      if (Date_WeekOfYear($mm,$dd,$yy,7)==2) {
         $f{"L"}=$yy;
         $f{"U"}=1;
@@ -1851,5 +1741,5 @@
     $mm=12;
     $f{"G"}=$yy;
-    $f{"W"}=&Date_WeekOfYear($mm,$dd,$yy,1)+1;
+    $f{"W"}=Date_WeekOfYear($mm,$dd,$yy,1)+1;
   }
   if ($f{"U"}==0) {
@@ -1860,5 +1750,5 @@
     $mm=12;
     $f{"L"}=$yy;
-    $f{"U"}=&Date_WeekOfYear($mm,$dd,$yy,7)+1;
+    $f{"U"}=Date_WeekOfYear($mm,$dd,$yy,7)+1;
   }
 
@@ -1867,15 +1757,15 @@
 
   # day
-  $f{"j"}=&Date_DayOfYear($m,$d,$y);
+  $f{"j"}=Date_DayOfYear($m,$d,$y);
   $f{"j"} = "0" . $f{"j"}   while (length($f{"j"})<3);
   $_=$d;
   s/^0/ /;
   $f{"e"}=$_;
-  $f{"w"}=&Date_DayOfWeek($m,$d,$y);
+  $f{"w"}=Date_DayOfWeek($m,$d,$y);
   $f{"v"}=$Lang{$Cnf{"Language"}}{"WL"}[$f{"w"}-1];
   $f{"v"}=" ".$f{"v"}  if (length $f{"v"} < 2);
   $f{"a"}=$Lang{$Cnf{"Language"}}{"WkL"}[$f{"w"}-1];
   $f{"A"}=$Lang{$Cnf{"Language"}}{"WeekL"}[$f{"w"}-1];
-  $f{"E"}=&Date_DaySuffix($f{"e"});
+  $f{"E"}=Date_DaySuffix($f{"e"});
 
   # hour
@@ -1895,6 +1785,6 @@
 
   # minute, second, timezone
-  $f{"o"}=&Date_SecsSince1970($m,$d,$y,$h,$mn,$s);
-  $f{"s"}=&Date_SecsSince1970GMT($m,$d,$y,$h,$mn,$s);
+  $f{"o"}=Date_SecsSince1970($m,$d,$y,$h,$mn,$s);
+  $f{"s"}=Date_SecsSince1970GMT($m,$d,$y,$h,$mn,$s);
   $f{"Z"}=($Cnf{"ConvTZ"} eq "IGNORE" or $Cnf{"ConvTZ"} eq "") ?
            $Cnf{"TZ"} : $Cnf{"ConvTZ"};
@@ -1919,5 +1809,5 @@
   if ($f{"W"}==0) {
     $y--;
-    $tmp=&Date_WeekOfYear(12,31,$y,1);
+    $tmp=Date_WeekOfYear(12,31,$y,1);
     $tmp="0$tmp"  if (length($tmp) < 2);
     $f{"J"}=qq|$y-W$tmp-$f{"w"}|;
@@ -1945,8 +1835,8 @@
         $c=chop($format);
         if ($c eq "l") {
-          &Date_Init();
-          $date1=&DateCalc_DateDelta($Curr{"Now"},"-0:6:0:0:0:0:0");
-          $date2=&DateCalc_DateDelta($Curr{"Now"},"+0:6:0:0:0:0:0");
-          if (&Date_Cmp($date,$date1)>=0  &&  &Date_Cmp($date,$date2)<=0) {
+          Date_Init();
+          $date1=_DateCalc_DateDelta($Curr{"Now"},"-0:6:0:0:0:0:0");
+          $date2=_DateCalc_DateDelta($Curr{"Now"},"+0:6:0:0:0:0:0");
+          if (Date_Cmp($date,$date1)>=0  &&  Date_Cmp($date,$date2)<=0) {
             $f{"l"}=qq|$f{"b"} $f{"e"} $h:$mn|;
           } else {
@@ -1986,9 +1876,9 @@
   my($dec,@format) = @arg;
 
-  $delta=&ParseDateDelta($delta);
+  $delta=ParseDateDelta($delta);
   return ""  if (! $delta);
   my(@out,%f,$out,$c1,$c2,$scalar,$format)=();
   local($_)=$delta;
-  my($y,$M,$w,$d,$h,$m,$s)=&Delta_Split($delta);
+  my($y,$M,$w,$d,$h,$m,$s)=_Delta_Split($delta);
   # Get rid of positive signs.
   ($y,$M,$w,$d,$h,$m,$s)=map { 1*$_; }($y,$M,$w,$d,$h,$m,$s);
@@ -2119,5 +2009,5 @@
 sub ParseRecur {
   print "DEBUG: ParseRecur\n"  if ($Curr{"Debug"} =~ /trace/);
-  &Date_Init()  if (! $Curr{"InitDone"});
+  Date_Init()  if (! $Curr{"InitDone"});
 
   my($recur,$dateb,$date0,$date1,$flag)=@_;
@@ -2157,13 +2047,13 @@
 
   if ($dateb) {
-    $dateb=&ParseDateString($dateb);
+    $dateb=ParseDateString($dateb);
     return ""  if (! $dateb);
   }
   if ($date0) {
-    $date0=&ParseDateString($date0);
+    $date0=ParseDateString($date0);
     return ""  if (! $date0);
   }
   if ($date1) {
-    $date1=&ParseDateString($date1);
+    $date1=ParseDateString($date1);
     return ""  if (! $date1);
   }
@@ -2174,5 +2064,5 @@
   #
 
-  @tmp=&Recur_Split($_);
+  @tmp=_Recur_Split($_);
 
   if (@tmp) {
@@ -2190,13 +2080,13 @@
 
     if ($date_b) {
-      $date_b=&ParseDateString($date_b);
+      $date_b=ParseDateString($date_b);
       return ""  if (! $date_b);
     }
     if ($date_0) {
-      $date_0=&ParseDateString($date_0);
+      $date_0=ParseDateString($date_0);
       return ""  if (! $date_0);
     }
     if ($date_1) {
-      $date_1=&ParseDateString($date_1);
+      $date_1=ParseDateString($date_1);
       return ""  if (! $date_1);
     }
@@ -2251,11 +2141,11 @@
         if ($m) {
           $m=$mmm{lc($m)};
-          $date_0=&Date_Join($y,$m,1,0,0,0);
-          $date_1=&DateCalc_DateDelta($date_0,"+0:1:0:0:0:0:0",0);
+          $date_0=_Date_Join($y,$m,1,0,0,0);
+          $date_1=_DateCalc_DateDelta($date_0,"+0:1:0:0:0:0:0",0);
         } else {
-          $date_0=&Date_Join($y,  1,1,0,0,0);
-          $date_1=&Date_Join($y+1,1,1,0,0,0);
+          $date_0=_Date_Join($y,  1,1,0,0,0);
+          $date_1=_Date_Join($y+1,1,1,0,0,0);
         }
-        $date_b=&DateCalc($date_0,"-0:0:0:1:0:0:0",0);
+        $date_b=DateCalc($date_0,"-0:0:0:1:0:0:0",0);
         @recur0=(0,0,0,$num,0,0,0);
         @recur1=();
@@ -2266,6 +2156,6 @@
         $y=$Curr{"Y"}  if (! $y);
 
-        $date_0=&Date_Join($y,  1,1,0,0,0);
-        $date_1=&Date_Join($y+1,1,1,0,0,0);
+        $date_0=_Date_Join($y,  1,1,0,0,0);
+        $date_1=_Date_Join($y+1,1,1,0,0,0);
         $date_b=$date_0;
 
@@ -2282,6 +2172,6 @@
         $num=-1  if ($num !~ /^$D$/);
 
-        $date_0=&Date_Join($y,1,1,0,0,0);
-        $date_1=&Date_Join($y+1,1,1,0,0,0);
+        $date_0=_Date_Join($y,1,1,0,0,0);
+        $date_1=_Date_Join($y+1,1,1,0,0,0);
         $date_b=$date_0;
 
@@ -2301,11 +2191,11 @@
         if ($m) {
           $m=$mmm{lc($m)};
-          $date_0=&Date_Join($y,$m,1,0,0,0);
-          $date_1=&DateCalc_DateDelta($date_0,"+0:1:0:0:0:0:0",0);
+          $date_0=_Date_Join($y,$m,1,0,0,0);
+          $date_1=_DateCalc_DateDelta($date_0,"+0:1:0:0:0:0:0",0);
         } else {
-          $date_0=&Date_Join($y,1,1,0,0,0);
-          $date_1=&Date_Join($y+1,1,1,0,0,0);
+          $date_0=_Date_Join($y,1,1,0,0,0);
+          $date_1=_Date_Join($y+1,1,1,0,0,0);
         }
-        $date_b=&DateCalc($date_0,"-0:0:0:1:0:0:0",0);
+        $date_b=DateCalc($date_0,"-0:0:0:1:0:0:0",0);
 
         @recur0=(0,0,$num);
@@ -2395,12 +2285,12 @@
       # Y-M-W-D-H-MN-S
 
-      @y=&ReturnList($y);
+      @y=_ReturnList($y);
       foreach $y (@y) {
-        $y=&Date_FixYear($y)  if (length($y)==2);
-        return ()  if (length($y)!=4  ||  ! &IsInt($y));
+        $y=_Date_FixYear($y)  if (length($y)==2);
+        return ()  if (length($y)!=4  ||  ! _IsInt($y));
       }
 
-      $date0=&ParseDate("0000-01-01")          if (! $date0);
-      $date1=&ParseDate("9999-12-31 23:59:59") if (! $date1);
+      $date0=ParseDate("0000-01-01")          if (! $date0);
+      $date1=ParseDate("9999-12-31 23:59:59") if (! $date1);
 
       if ($m eq "0"  and  $w eq "0") {
@@ -2412,8 +2302,8 @@
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
           return ()  if (! @d);
           foreach $d (@d) {
-            return ()  if (! &IsInt($d,-366,366)  ||  $d==0);
+            return ()  if (! _IsInt($d,-366,366)  ||  $d==0);
           }
         }
@@ -2421,11 +2311,11 @@
         @date=();
         foreach $yy (@y) {
-          my $diy = &Date_DaysInYear($yy);
+          my $diy = Date_DaysInYear($yy);
           foreach $d (@d) {
             my $tmpd = $d;
             $tmpd += ($diy+1)  if ($tmpd < 0);
-            next  if (! &IsInt($tmpd,1,$diy));
-            ($y,$m,$dd)=&Date_NthDayOfYear($yy,$tmpd);
-            push(@date, &Date_Join($y,$m,$dd,0,0,0));
+            next  if (! _IsInt($tmpd,1,$diy));
+            ($y,$m,$dd)=Date_NthDayOfYear($yy,$tmpd);
+            push(@date, _Date_Join($y,$m,$dd,0,0,0));
           }
         }
@@ -2437,8 +2327,8 @@
         # * Y-M-0-DOM-H-MN-S
 
-        @m=&ReturnList($m);
+        @m=_ReturnList($m);
         return ()  if (! @m);
         foreach $m (@m) {
-          return ()  if (! &IsInt($m,1,12));
+          return ()  if (! _IsInt($m,1,12));
         }
 
@@ -2446,8 +2336,8 @@
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
           return ()  if (! @d);
           foreach $d (@d) {
-            return ()  if (! &IsInt($d,-31,31)  ||  $d==0);
+            return ()  if (! _IsInt($d,-31,31)  ||  $d==0);
           }
         }
@@ -2456,10 +2346,10 @@
         foreach $y (@y) {
           foreach $m (@m) {
-            my $dim = &Date_DaysInMonth($m,$y);
+            my $dim = Date_DaysInMonth($m,$y);
             foreach $d (@d) {
               my $tmpd = $d;
               $tmpd += ($dim+1)  if ($d<0);
-              next  if (! &IsInt($tmpd,1,$dim));
-              $date=&Date_Join($y,$m,$tmpd,0,0,0);
+              next  if (! _IsInt($tmpd,1,$dim));
+              $date=_Date_Join($y,$m,$tmpd,0,0,0);
               push(@date,$date);
             }
@@ -2473,8 +2363,8 @@
         # * Y-0-WOY-0-H-MN-S
 
-        @w=&ReturnList($w);
+        @w=_ReturnList($w);
         return ()  if (! @w);
         foreach $w (@w) {
-          return ()  if (! &IsInt($w,-53,53)  ||  $w==0);
+          return ()  if (! _IsInt($w,-53,53)  ||  $w==0);
         }
 
@@ -2482,9 +2372,9 @@
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
           return ()  if (! @d);
           foreach $d (@d) {
             $d += 8  if ($d<0);
-            return ()  if (! &IsInt($d,1,7));
+            return ()  if (! _IsInt($d,1,7));
           }
         }
@@ -2506,6 +2396,6 @@
                 $date=Date_GetNext($date,$d,1);
               }
-              $date=&DateCalc_DateDelta($date,$del);
-              push(@date,$date)  if ( (&Date_Split($date))[0] == $y);
+              $date=_DateCalc_DateDelta($date,$del);
+              push(@date,$date)  if ( (_Date_Split($date))[0] == $y);
             }
           }
@@ -2518,15 +2408,15 @@
         # * Y-M-WOM-0-H-MN-S
 
-        @m=&ReturnList($m);
+        @m=_ReturnList($m);
         return ()  if (! @m);
-        @w=&ReturnList($w);
+        @w=_ReturnList($w);
         return ()  if (! @w);
         if ($d eq "0") {
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
         }
 
-        @date=&Date_Recur_WoM(\@y,\@m,\@w,\@d);
+        @date=_Date_Recur_WoM(\@y,\@m,\@w,\@d);
         last RECUR;
       }
@@ -2550,8 +2440,8 @@
         return ()  if (! $dateb  &&  $y != 1);
 
-        @m=&ReturnList($m);
+        @m=_ReturnList($m);
         return ()  if (! @m);
         foreach $m (@m) {
-          return ()  if (! &IsInt($m,1,12));
+          return ()  if (! _IsInt($m,1,12));
         }
 
@@ -2559,16 +2449,16 @@
           @d = (1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
           return ()  if (! @d);
           foreach $d (@d) {
-            return ()  if (! &IsInt($d,-31,31)  ||  $d==0);
+            return ()  if (! _IsInt($d,-31,31)  ||  $d==0);
           }
         }
 
         # We need to find years that are a multiple of $n from $y(base)
-        ($y0)=( &Date_Split($date0, 1) )[0];
-        ($y1)=( &Date_Split($date1, 1) )[0];
+        ($y0)=( _Date_Split($date0, 1) )[0];
+        ($y1)=( _Date_Split($date1, 1) )[0];
         if ($dateb) {
-          ($yb)=( &Date_Split($dateb, 1) )[0];
+          ($yb)=( _Date_Split($dateb, 1) )[0];
         } else {
           # If $y=1, there is no base year
@@ -2581,11 +2471,11 @@
             foreach $m (@m) {
               foreach $d (@d) {
-                my $dim  = &Date_DaysInMonth($m,$yy);
+                my $dim  = Date_DaysInMonth($m,$yy);
                 my $tmpd = $d;
                 if ($tmpd < 0) {
                   $tmpd += ($dim+1);
                 }
-                next  if (! &IsInt($tmpd,1,$dim));
-                $date=&Date_Join($yy,$m,$tmpd,0,0,0);
+                next  if (! _IsInt($tmpd,1,$dim));
+                $date=_Date_Join($yy,$m,$tmpd,0,0,0);
                 push(@date,$date);
               }
@@ -2601,7 +2491,7 @@
         return ()  if (! $dateb  &&  $y != 1);
 
-        @m=&ReturnList($m);
+        @m=_ReturnList($m);
         return ()  if (! @m);
-        @w=&ReturnList($w);
+        @w=_ReturnList($w);
         return ()  if (! @w);
 
@@ -2609,11 +2499,11 @@
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
         }
 
-        ($y0)=( &Date_Split($date0, 1) )[0];
-        ($y1)=( &Date_Split($date1, 1) )[0];
+        ($y0)=( _Date_Split($date0, 1) )[0];
+        ($y1)=( _Date_Split($date1, 1) )[0];
         if ($dateb) {
-          ($yb)=( &Date_Split($dateb, 1) )[0];
+          ($yb)=( _Date_Split($dateb, 1) )[0];
         } else {
           # If $y=1, there is no base year
@@ -2627,5 +2517,5 @@
         }
 
-        @date=&Date_Recur_WoM(\@y,\@m,\@w,\@d);
+        @date=_Date_Recur_WoM(\@y,\@m,\@w,\@d);
         last RECUR;
       }
@@ -2649,8 +2539,8 @@
         $n=1  if ($n==0);
 
-        @w=&ReturnList($w);
+        @w=_ReturnList($w);
         return ()  if (! @w);
         foreach $w (@w) {
-          return ()  if ($w==0  ||  ! &IsInt($w,-53,53));
+          return ()  if ($w==0  ||  ! _IsInt($w,-53,53));
         }
 
@@ -2658,17 +2548,17 @@
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
           return ()  if (! @d);
           foreach $d (@d) {
             $d += 8  if ($d<0);
-            return ()  if (! &IsInt($d,1,7));
+            return ()  if (! _IsInt($d,1,7));
           }
         }
 
         # We need to find years that are a multiple of $n from $y(base)
-        ($y0)=( &Date_Split($date0, 1) )[0];
-        ($y1)=( &Date_Split($date1, 1) )[0];
+        ($y0)=( _Date_Split($date0, 1) )[0];
+        ($y1)=( _Date_Split($date1, 1) )[0];
         if ($dateb) {
-          ($yb)=( &Date_Split($dateb, 1) )[0];
+          ($yb)=( _Date_Split($dateb, 1) )[0];
         } else {
           # If $y=1, there is no base year
@@ -2693,6 +2583,6 @@
                   $date=Date_GetNext($date,$d,1);
                 }
-                $date=&DateCalc($date,$del);
-                next  if ((&Date_Split($date))[0] != $yy);
+                $date=DateCalc($date,$del);
+                next  if ((_Date_Split($date))[0] != $yy);
                 push(@date,$date);
               }
@@ -2706,19 +2596,20 @@
         # Y-M * WOM-0-H-MN-S
         # Y-M * WOM-DOW-H-MN-S
-        return ()  if (! $dateb);
+        return ()  if (! $dateb  &&  ($y != 0  ||  $m != 1));
         @tmp=(@recur0);
         push(@tmp,0)  while ($#tmp<6);
         $delta=join(":",@tmp);
-        @tmp=&Date_Recur($date0,$date1,$dateb,$delta);
-
-        @w=&ReturnList($w);
+        $dateb=$date0  if (! $dateb);
+        @tmp=_Date_Recur($date0,$date1,$dateb,$delta);
+
+        @w=_ReturnList($w);
         @m=();
         if ($d eq "0") {
           @d=(1);
         } else {
-          @d=&ReturnList($d);
+          @d=_ReturnList($d);
         }
 
-        @date=&Date_Recur_WoM(\@tmp,\@m,\@w,\@d);
+        @date=_Date_Recur_WoM(\@tmp,\@m,\@w,\@d);
         last RECUR;
       }
@@ -2734,5 +2625,5 @@
         $y=1  if ($y==0 && $m==0 && $w==0);
         $delta="$y:$m:$w:0:0:0:0";
-        @date=&Date_Recur($date0,$date1,$dateb,$delta);
+        @date=_Date_Recur($date0,$date1,$dateb,$delta);
         last RECUR;
 
@@ -2744,15 +2635,15 @@
         return ()  if (! $dateb  &&  $y!=1);
 
-        @d=&ReturnList($d);
+        @d=_ReturnList($d);
         return ()  if (! @d);
         foreach $d (@d) {
-          return ()  if (! &IsInt($d,-366,366)  ||  $d==0);
+          return ()  if (! _IsInt($d,-366,366)  ||  $d==0);
         }
 
         # We need to find years that are a multiple of $n from $y(base)
-        ($y0)=( &Date_Split($date0, 1) )[0];
-        ($y1)=( &Date_Split($date1, 1) )[0];
+        ($y0)=( _Date_Split($date0, 1) )[0];
+        ($y1)=( _Date_Split($date1, 1) )[0];
         if ($dateb) {
-          ($yb)=( &Date_Split($dateb, 1) )[0];
+          ($yb)=( _Date_Split($dateb, 1) )[0];
         } else {
           # If $y=1, there is no base year
@@ -2761,12 +2652,12 @@
         @date=();
         for ($yy=$y0; $yy<=$y1; $yy++) {
-          my $diy = &Date_DaysInYear($yy);
+          my $diy = Date_DaysInYear($yy);
           if (($yy-$yb)%$n == 0) {
             foreach $d (@d) {
               my $tmpd = $d;
               $tmpd += ($diy+1)  if ($tmpd<0);
-              next  if (! &IsInt($tmpd,1,$diy));
-              ($y,$m,$dd)=&Date_NthDayOfYear($yy,$tmpd);
-              push(@date, &Date_Join($y,$m,$dd,0,0,0));
+              next  if (! _IsInt($tmpd,1,$diy));
+              ($y,$m,$dd)=Date_NthDayOfYear($yy,$tmpd);
+              push(@date, _Date_Join($y,$m,$dd,0,0,0));
             }
           }
@@ -2777,19 +2668,20 @@
 
         # Y-M-W * DOW-H-MN-S
-        return ()  if (! $dateb);
+        return ()  if (! $dateb  &&  ($y != 0  &&  $m != 0  &&  $w != 1));
         @tmp=(@recur0);
         push(@tmp,0)  while ($#tmp<6);
         $delta=join(":",@tmp);
 
-        @d=&ReturnList($d);
+        @d=_ReturnList($d);
         return ()  if (! @d);
         foreach $d (@d) {
           $d += 8  if ($d<0);
-          return ()  if (! &IsInt($d,1,7));
+          return ()  if (! _IsInt($d,1,7));
         }
 
         # Find out what DofW the basedate is.
-        @tmp2=&Date_Split($dateb, 1);
-        $tmp=&Date_DayOfWeek($tmp2[1],$tmp2[2],$tmp2[0]);
+        $dateb = $date0  if (! $dateb);
+        @tmp2=_Date_Split($dateb, 1);
+        $tmp=Date_DayOfWeek($tmp2[1],$tmp2[2],$tmp2[0]);
 
         @date=();
@@ -2801,10 +2693,10 @@
                 ($tmp>=$Cnf{"FirstDay"} && $d>$tmp) ||
                 ($tmp<$d && $d<$Cnf{"FirstDay"})) {
-              $date_b=&Date_GetNext($date_b,$d);
+              $date_b=Date_GetNext($date_b,$d);
             } else {
-              $date_b=&Date_GetPrev($date_b,$d);
+              $date_b=Date_GetPrev($date_b,$d);
             }
           }
-          push(@date,&Date_Recur($date0,$date1,$date_b,$delta));
+          push(@date,_Date_Recur($date0,$date1,$date_b,$delta));
         }
         last RECUR;
@@ -2813,25 +2705,26 @@
 
         # Y-M-0 * DOM-H-MN-S
-        return ()  if (! $dateb);
+        return ()  if (! $dateb  &&  ($y != 0  &&  $m != 1));
         @tmp=(@recur0);
         push(@tmp,0)  while ($#tmp<6);
         $delta=join(":",@tmp);
 
-        @d=&ReturnList($d);
+        @d=_ReturnList($d);
         return ()  if (! @d);
         foreach $d (@d) {
-          return ()  if ($d==0  ||  ! &IsInt($d,-31,31));
+          return ()  if ($d==0  ||  ! _IsInt($d,-31,31));
         }
-
-        @tmp2=&Date_Recur($date0,$date1,$dateb,$delta);
+        $dateb = $date0  if (! $dateb);
+
+        @tmp2=_Date_Recur($date0,$date1,$dateb,$delta);
         @date=();
         foreach $date (@tmp2) {
-          ($y,$m)=( &Date_Split($date, 1) )[0..1];
-          my $dim=&Date_DaysInMonth($m,$y);
+          ($y,$m)=( _Date_Split($date, 1) )[0..1];
+          my $dim=Date_DaysInMonth($m,$y);
           foreach $d (@d) {
             my $tmpd = $d;
             $tmpd += ($dim+1)  if ($tmpd<0);
-            next  if (! &IsInt($tmpd,1,$dim));
-            push(@date,&Date_Join($y,$m,$tmpd,0,0,0));
+            next  if (! _IsInt($tmpd,1,$dim));
+            push(@date,_Date_Join($y,$m,$tmpd,0,0,0));
           }
         }
@@ -2849,4 +2742,13 @@
       # Y-M-W-D-H-MN * S
       # Y-M-W-D-H-S
+      if (($#recur0 == 3  &&
+           ($y == 0  &&  $m == 0  &&  $w == 0  &&  $d == 1)) ||
+          ($#recur0 == 4  &&
+           ($y == 0  &&  $m == 0  &&  $w == 0  &&  $d == 0  &&  $h == 1)) ||
+          ($#recur0 == 5  &&
+           ($y == 0  &&  $m == 0  &&  $w == 0  &&  $d == 0  &&  $h == 0  &&
+            $mn == 1))) {
+         $dateb = $date0;
+      }
       return ()  if (! $dateb);
       @tmp=(@recur0);
@@ -2854,5 +2756,5 @@
       $delta=join(":",@tmp);
       return ()  if ($delta !~ /[1-9]/); # return if "0:0:0:0:0:0:0"
-      @date=&Date_Recur($date0,$date1,$dateb,$delta);
+      @date=_Date_Recur($date0,$date1,$dateb,$delta);
       if (@recur1) {
         unshift(@recur1,-1)  while ($#recur1<2);
@@ -2867,5 +2769,5 @@
     last RECUR;
   }
-  @date=&Date_RecurSetTime($date0,$date1,\@date,@time)  if (@time);
+  @date=_Date_RecurSetTime($date0,$date1,\@date,@time)  if (@time);
 
   #
@@ -2886,7 +2788,7 @@
         foreach $date (@date) {
           if ($forw) {
-            push(@tmp, &Date_GetNext($date,$d,$today));
+            push(@tmp, Date_GetNext($date,$d,$today));
           } else {
-            push(@tmp, &Date_GetPrev($date,$d,$today));
+            push(@tmp, Date_GetPrev($date,$d,$today));
           }
         }
@@ -2909,6 +2811,6 @@
           for ($i=1; $i<=$n; $i++) {
             while (1) {
-              $date=&DateCalc($date,"${sign}0:0:0:1:0:0:0");
-              last if (! $work  ||  &Date_IsWorkDay($date,0));
+              $date=DateCalc($date,"${sign}0:0:0:1:0:0:0");
+              last if (! $work  ||  Date_IsWorkDay($date,0));
             }
           }
@@ -2931,5 +2833,5 @@
       DATE: foreach $date (@date) {
           $df=$db=$date;
-          if (&Date_IsWorkDay($date)) {
+          if (Date_IsWorkDay($date)) {
             push(@tmp,$date);
             next DATE;
@@ -2937,9 +2839,9 @@
           while (1) {
             if ($forw) {
-              $d=$df=&DateCalc($df,"+0:0:0:1:0:0:0");
+              $d=$df=DateCalc($df,"+0:0:0:1:0:0:0");
             } else {
-              $d=$db=&DateCalc($db,"-0:0:0:1:0:0:0");
+              $d=$db=DateCalc($db,"-0:0:0:1:0:0:0");
             }
-            if (&Date_IsWorkDay($d)) {
+            if (Date_IsWorkDay($d)) {
               push(@tmp,$d);
               next DATE;
@@ -2955,9 +2857,9 @@
         @tmp=();
         foreach $date (@date) {
-          ($y,$m,$d,$h,$mn,$s)=&Date_Split($date, 1);
-          ($m,$d)=&Date_Easter($y);
-          $date=&Date_Join($y,$m,$d,$h,$mn,$s);
-          next  if (&Date_Cmp($date,$date0)<0  ||
-                    &Date_Cmp($date,$date1)>0);
+          ($y,$m,$d,$h,$mn,$s)=_Date_Split($date, 1);
+          ($m,$d)=_Date_Easter($y);
+          $date=_Date_Join($y,$m,$d,$h,$mn,$s);
+          next  if (Date_Cmp($date,$date0)<0  ||
+                    Date_Cmp($date,$date1)>0);
           push(@tmp,$date);
         }
@@ -2974,5 +2876,5 @@
   print "DEBUG: Date_GetPrev\n"  if ($Curr{"Debug"} =~ /trace/);
   my($date,$dow,$today,$hr,$min,$sec)=@_;
-  &Date_Init()  if (! $Curr{"InitDone"});
+  Date_Init()  if (! $Curr{"InitDone"});
   my($y,$m,$d,$h,$mn,$s,$err,$curr_dow,%dow,$num,$delta,$th,$tm,$ts,
      $adjust,$curr)=();
@@ -2981,15 +2883,15 @@
   $sec="00"  if (defined $sec  &&  $sec eq "0");
 
-  if (! &Date_Split($date)) {
-    $date=&ParseDateString($date);
+  if (! _Date_Split($date)) {
+    $date=ParseDateString($date);
     return ""  if (! $date);
   }
   $curr=$date;
-  ($y,$m,$d)=( &Date_Split($date, 1) )[0..2];
+  ($y,$m,$d)=( _Date_Split($date, 1) )[0..2];
 
   if ($dow) {
-    $curr_dow=&Date_DayOfWeek($m,$d,$y);
+    $curr_dow=Date_DayOfWeek($m,$d,$y);
     %dow=%{ $Lang{$Cnf{"Language"}}{"WeekH"} };
-    if (&IsInt($dow)) {
+    if (_IsInt($dow)) {
       return ""  if ($dow<1  ||  $dow>7);
     } else {
@@ -2998,18 +2900,18 @@
     }
     if ($dow == $curr_dow) {
-      $date=&DateCalc_DateDelta($date,"-0:0:1:0:0:0:0",\$err,0)  if (! $today);
+      $date=_DateCalc_DateDelta($date,"-0:0:1:0:0:0:0",\$err,0)  if (! $today);
       $adjust=1  if ($today==2);
     } else {
       $dow -= 7  if ($dow>$curr_dow); # make sure previous day is less
       $num = $curr_dow - $dow;
-      $date=&DateCalc_DateDelta($date,"-0:0:0:$num:0:0:0",\$err,0);
-    }
-    $date=&Date_SetTime($date,$hr,$min,$sec)  if (defined $hr);
-    $date=&DateCalc_DateDelta($date,"-0:0:1:0:0:0:0",\$err,0)
-      if ($adjust  &&  &Date_Cmp($date,$curr)>0);
+      $date=_DateCalc_DateDelta($date,"-0:0:0:$num:0:0:0",\$err,0);
+    }
+    $date=Date_SetTime($date,$hr,$min,$sec)  if (defined $hr);
+    $date=_DateCalc_DateDelta($date,"-0:0:1:0:0:0:0",\$err,0)
+      if ($adjust  &&  Date_Cmp($date,$curr)>0);
 
   } else {
-    ($h,$mn,$s)=( &Date_Split($date, 1) )[3..5];
-    ($th,$tm,$ts)=&Date_ParseTime($hr,$min,$sec);
+    ($h,$mn,$s)=( _Date_Split($date, 1) )[3..5];
+    ($th,$tm,$ts)=_Date_ParseTime($hr,$min,$sec);
     if ($hr) {
       ($hr,$min,$sec)=($th,$tm,$ts);
@@ -3025,9 +2927,9 @@
     }
 
-    $d=&Date_SetTime($date,$hr,$min,$sec);
+    $d=Date_SetTime($date,$hr,$min,$sec);
     if ($today) {
-      $d=&DateCalc_DateDelta($d,$delta,\$err,0)  if (&Date_Cmp($d,$date)>0);
+      $d=_DateCalc_DateDelta($d,$delta,\$err,0)  if (Date_Cmp($d,$date)>0);
     } else {
-      $d=&DateCalc_DateDelta($d,$delta,\$err,0)  if (&Date_Cmp($d,$date)>=0);
+      $d=_DateCalc_DateDelta($d,$delta,\$err,0)  if (Date_Cmp($d,$date)>=0);
     }
     $date=$d;
@@ -3039,5 +2941,5 @@
   print "DEBUG: Date_GetNext\n"  if ($Curr{"Debug"} =~ /trace/);
   my($date,$dow,$today,$hr,$min,$sec)=@_;
-  &Date_Init()  if (! $Curr{"InitDone"});
+  Date_Init()  if (! $Curr{"InitDone"});
   my($y,$m,$d,$h,$mn,$s,$err,$curr_dow,%dow,$num,$delta,$th,$tm,$ts,
      $adjust,$curr)=();
@@ -3046,15 +2948,15 @@
   $sec="00"  if (defined $sec  &&  $sec eq "0");
 
-  if (! &Date_Split($date)) {
-    $date=&ParseDateString($date);
+  if (! _Date_Split($date)) {
+    $date=ParseDateString($date);
     return ""  if (! $date);
   }
   $curr=$date;
-  ($y,$m,$d)=( &Date_Split($date, 1) )[0..2];
+  ($y,$m,$d)=( _Date_Split($date, 1) )[0..2];
 
   if ($dow) {
-    $curr_dow=&Date_DayOfWeek($m,$d,$y);
+    $curr_dow=Date_DayOfWeek($m,$d,$y);
     %dow=%{ $Lang{$Cnf{"Language"}}{"WeekH"} };
-    if (&IsInt($dow)) {
+    if (_IsInt($dow)) {
       return ""  if ($dow<1  ||  $dow>7);
     } else {
